/*
VierGewinnt -- Learning Java
Copyright (C) <2006>  Robin and Detlef Wolf
This library is free software -- GNU LGPL license applies.
see http://www.gnu.org/licenses/lgpl.txt for details
*/


// part of the user interface: display field to user

import javax.swing.JPanel; 
import java.awt.GridLayout ;
import java.awt.Color ;

public class FieldPanel extends JPanel implements ObserverInterface {

  private VierGewinntModel model ;

  public FieldPanel(VierGewinntModel model) {
    this.model = model ;
    model.register(this) ;
    setLayout(new GridLayout(model.f.rowNum, model.f.columnNum, 5, 5));
    setBackground(new Color(140,140,140)) ;
    modelUpdate() ;
  }

  public void modelUpdate() {
    removeAll() ;
    for (int row=0; row<model.f.rowNum; ++row)
      for (int col=0; col<model.f.columnNum; ++col) {
        int who = model.f.field[model.f.rowNum-1-row][col] ;
        Stone l = new Stone(who) ;
        add(l) ;
      }
    revalidate() ;
    repaint() ;
  }
}

