/*
VierGewinnt -- Learning Java
Copyright (C) <2006>  Robin and Detlef Wolf
This library is free software -- GNU LGPL license applies.
see http://www.gnu.org/licenses/lgpl.txt for details
*/

// draw one playing stone or place to put a stone

import javax.swing.JPanel; 
import javax.swing.SwingConstants ;

import java.awt.Dimension ;
import java.awt.Color ;
import java.awt.Graphics ;
import java.awt.Image ;
import java.awt.Toolkit ;
import java.net.URL ;
import java.net.MalformedURLException ;


public class Stone extends JPanel {

  int who ;
  Image img = null ;
  Color human =    new Color(0, 0, 255, 110) ;
  Color computer = new Color(255, 255, 0, 110) ;

  static String stoneURI = null ; // stone image to load

  // this was made to allow using unsigned applets / webstart apps
  // if running in an applet, get the URL for the stone image from the
  // applet params, if running in webstart, get it from the JNLP file
  // else assume we are running on command line and get if from file.
  static String getStoneURI() {
    if (stoneURI != null)
      return stoneURI ;
    stoneURI = VierGewinntApplet.getStoneURI() ;
    if (stoneURI == null)
      stoneURI = System.getProperty("jnlp.stoneURI") ;
    if (stoneURI == null)
      stoneURI = "snowflakeSmile.gif" ;  // build in default
    return stoneURI ;
  }

  public Stone(int who) {
    super() ;
    setPreferredSize(new Dimension(80, 80));
    setOpaque(true) ;
    this.who = who ;
    setBackground(new Color(140,140,140)) ;
    if (getStoneURI().startsWith("http")) {
      try {
        img = Toolkit.getDefaultToolkit().getImage(new URL(getStoneURI())); 
      }
      catch (MalformedURLException e) {
        throw new RuntimeException("cannot load snowflake", e) ;
      }
    }
    else
      img = Toolkit.getDefaultToolkit().getImage(getStoneURI()) ;
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);    // paints background
    int h = getHeight() ;
    int w = getWidth() ;
    int d = (h < w ? h : w) - 4 ;  // diameter of stone
    int yr = (h - d) / 2 ;
    int xr = (w - d) / 2 ;

    if (who == 0) {
      g.setColor(Color.gray) ;
      g.fillOval(xr,yr,d,d) ;
    }
    else {
      g.setColor(who == 1 ? human : computer) ;
      g.drawImage(img, xr+6,yr+6,d-12,d-12, this) ;
      g.fillOval(xr,yr,d,d) ;
    }
  }


}

