/*
VierGewinnt -- Learning Java
Copyright (C) <2006>  Robin and Detlef Wolf
This library is free software -- GNU LGPL license applies.
see http://www.gnu.org/licenses/lgpl.txt for details
*/

// construct and place the elements of the user interface

import javax.swing.JPanel; 
import javax.swing.JButton;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JScrollPane;

import java.awt.GridBagLayout;  
import java.awt.GridBagConstraints;

import java.awt.event.ActionEvent ;
import java.awt.event.ActionListener;
import javax.swing.event.ChangeEvent ;
import javax.swing.event.ChangeListener;

public class VierGewinntPanel extends JPanel {

  public VierGewinntPanel(final VierGewinntModel model) {
  
    HumanMove humanMove = new HumanMove(model);
    FieldPanel fieldPanel = new FieldPanel(model) ;
    StatusLine statusLine = new StatusLine(model) ;
    GameLog gameLog = new GameLog() ;
    model.setGameLog(gameLog) ;
    JButton startComputerButton = new JButton("Start Computer") ;
    JButton startMenschButton = new JButton("Start Mensch") ;
    final JSpinner maxLevel = new JSpinner(
                          new SpinnerNumberModel(
                            new Integer(model.getMaxLevel()),
                            new Integer(1),
                            new Integer(8),
                            new Integer(1)
                          )
                        ) ;
    maxLevel.setToolTipText("Spielstrke einstellen (1 bis 8)") ;  // does not work
    statusLine.setToolTipText("Spielstrke einstellen (1 bis 8)") ;
       
    setLayout(new GridBagLayout());
    GridBagConstraints c = new GridBagConstraints();

    c.gridx = 0;
    c.gridy = 0;
    c.gridwidth = 3;
    c.fill = GridBagConstraints.HORIZONTAL ;
    c.weightx = 100 ;
    c.weighty = 1 ;
    add(humanMove, c);

    c.gridx = 0;
    c.gridy = 1;
    c.fill = GridBagConstraints.BOTH ;
    c.weightx = 100 ;
    c.weighty = 100 ;
    add(fieldPanel, c);

    c.weightx = 1 ;
    c.weighty = 1 ;
    c.fill = GridBagConstraints.NONE ;
    c.gridwidth = 1;
    c.gridx = 0;
    c.gridy = 3;
    add(startComputerButton, c) ;

    c.gridx = 1;
    c.gridy = 3;
    add(startMenschButton, c) ;

    c.gridx = 2;
    c.gridy = 3;
    add(maxLevel, c) ;

    c.anchor = GridBagConstraints.CENTER ;
    c.fill = GridBagConstraints.HORIZONTAL ;
    c.gridwidth = 3;
    c.gridx = 0;
    c.gridy = 2;
    add(statusLine, c) ;

    c.anchor = GridBagConstraints.CENTER ;
    c.fill = GridBagConstraints.HORIZONTAL ;
    c.gridwidth = 3;
    c.gridx = 0;
    c.gridy = 4;
    JScrollPane gameLogScrolPane = new JScrollPane(gameLog) ;
    gameLogScrolPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER) ;
    add(gameLogScrolPane , c) ;


    startComputerButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          model.startComputer() ;
        }
      }) ;

    startMenschButton.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          model.startMensch() ;
        }
      }) ;

    maxLevel.addChangeListener(new ChangeListener() {
        public void stateChanged(ChangeEvent e) {
          model.setMaxLevel(((Integer)maxLevel.getValue()).intValue()) ;
        }
      }) ;
  }

}

